extends Control
# StoryLibの選択肢画面
func _ready():
	Data.connect("set_choise_buttons", Callable(self, "_set_choise_buttons"))

func _set_choise_buttons():
	# ボタンのポジションを正確に反映させるため、コンテナの前にControlノードを配置しています
	var control_node = $ScrollContainer/Control
	var container_node = $ScrollContainer/Control/VBoxContainer
	var button_position = Vector2(0, 0)
	var buttons_size_y = 0
	# ScrollContainerのサイズ
	var scroll_container_size = $ScrollContainer.get_size()
	# ボタンの間隔
	var button_spacing = 50
	# 辞書に格納された最上位の階層の数だけ処理を繰り返す
	for i in range(len(Data.storylib_choices)):
		# インスタンスを生成する
		var choice_button = load(Data.nodes["choice_button"]).instantiate()
		choice_button.name = "Button " + str(int(i+1))
		choice_button.get_node("Label").set_text(Data.storylib_choices[i]["title"])
		choice_button.set_position(button_position)
		# ボタンが押された時に実行されるコールバックを設定
		choice_button.pressed.connect(_on_button_pressed.bind(i))
		# 念のため可視化オンにしてから配置
		choice_button.show()
		container_node.add_child(choice_button)
		# 次のボタンの位置を調整
		button_position.y += choice_button.size.y + button_spacing
		# ボタン全体の縦サイズを加算
		buttons_size_y += choice_button.get_size().y + button_spacing
	# Containerのサイズを取得
	var container_size = container_node.get_rect().size
	# Containerの位置を調整
	var container_position = Vector2(
		(scroll_container_size.x - container_size.x) / 2,
		(scroll_container_size.y - buttons_size_y) / 2
	)
	# 選択肢が画面に収まりきらない場合、Controlの縦のサイズを調整してコンテナの縦位置を固定する
	if buttons_size_y > scroll_container_size.y:
		control_node.set_custom_minimum_size(Vector2(control_node.get_rect().size.x, buttons_size_y))
		container_position = Vector2((scroll_container_size.x - container_size.x) / 2, 50)
	# 配置
	container_node.set_position(container_position)

# ボタンが押された時のコールバック
func _on_button_pressed(button_index):
	# ジャンプマーカーを適用させるシグナルをコアスクリプトに渡す
	Data.emit_signal("set_jump_marker", button_index)
	queue_free()
